


#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <util\delay.h>
#include "74595.h"

///GLOBAL VAR
SU_SHIFT_TTL74595_TYPE gSU_TTL74595; //Struct Union#

// *******************************************************************
void Write_OUT74HC595( uint8_t * pca74HC595 )  // mit pointer auf array
// *******************************************************************
{
uint8_t u8NN;
uint8_t u8AA; // 74595 Cnt
 
TTL74595_MR_LOW(); //Diese Leitung Knnte auch immer High sein.
_delay_us(1);
TTL74595_MR_HIGH(); // clear only SAhiftregister
TTL74595_SH_CP_LOW();
u8AA = NUMBER_OF_74595 -1;
do
	{
	u8NN = 7;
	do
		{  // Clock out bits from the eo array
		 if( gSU_TTL74595.gau8TTL74595[u8AA] & (1UL << u8NN) ) 	// Ist es undiert eine EINS ?
			{	 
			TTL74595_DS_HIGH();     
			}		 
		 else
			{	
			TTL74595_DS_LOW();	
			};	 
		TTL74595_SH_CP_HIGH();	//Shift clock
		_delay_us(1);
		TTL74595_SH_CP_LOW();
		_delay_us(1);
	  }while( u8NN-- );
	}while(u8AA--);  //NUMBER_OF_74595
TTL74595_ST_CP_HIGH(); // Latch Data to Output
_delay_us(1);
TTL74595_SH_CP_LOW();
TTL74595_ST_CP_LOW();
};
