

/*

der LTC1298 kommt auch als LTC1286 vor
12 BIT AD 
LTC1286 = 1 Cahnnel DUAL +/- Eingang ext VREF
LTC1298 = 2 Channel 
*/

#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include <math.h>

#include <ctype.h>
#include <inttypes.h>
#include <string.h>
#include "LTC1298.h"
#include <avr\io.h>



#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <avr\iom8.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>

//#include <avr\eeprom.h>	

//ACHTUNG STELLT OBSOLETE Procedure in header wieder her
#include <compat\deprecated.h>

//#include <avr\twi.h> /* Note [1] */  // NEUE DATEIVERSION_STR BEUNTZEN
//#include <avr\signal.h> //#include <signal.h>

#include <avr\wdt.h>
//Produziert Fehler...
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms


ADC_CALCULATE_TYPE gsLTC1298;
uint16_t	gu16SelectedRingBufSize = RINGBUF_SIZE_MAX;
uint16_t gau16ADC_RingBuf[ RINGBUF_SIZE_MAX ];
uint16_t * gpu16RingBuf_Parser;
uint16_t * gpu16RingBuf_Tail;


// **********************************************
uint16_t ADC_12Bit_LTC1298( uint8_t u8Din )  // DAUER ETWA 34S
//clk FRQ = <200KhZ  = 5S/Perdiode = 2 was tun 2S
// ********************************************** 
{
uint16_t u16Val=0;
uint8_t u8NN;
//CLR_ADC_LTC1298_CLK();
CLR_ADC_LTC1298_SHDN();
u8NN = 3;
do
{
if( u8Din & (1 << u8NN) )
	{
	SET_ADC_LTC1298_DIN();
	}
else
	{
	CLR_ADC_LTC1298_DIN();
	};
_delay_us( 2 );
SET_ADC_LTC1298_CLK();
_delay_us( 2 );
CLR_ADC_LTC1298_CLK();
}while(u8NN--);

//PLUS NULLBIT
//CLR_ADC_LTC1298_DIN();
_delay_us( 2 );
SET_ADC_LTC1298_CLK();
_delay_us( 2 );
CLR_ADC_LTC1298_CLK();

u8NN = 11;
do
{
_delay_us( 2 );
SET_ADC_LTC1298_CLK();
_delay_us( 1 ); //Lese nach Setzen mit pause
if( READ_ADC_LTC1298_DOUT()  )
	{
	u16Val |= (1 << u8NN);
	};
_delay_us( 1 );	// 200Khzclk,	nochmalswarten 
CLR_ADC_LTC1298_CLK();
}while(u8NN--);
SET_ADC_LTC1298_SHDN();

return u16Val;
};



//Diese Funktion ist 1* auszufhren, und zwar beim Start, und vor dem mainloop()
// ************************************************
void Init_LTC1298_Values( void)
// ************************************************
{	//Defaultwerte im Header
SET_ADC_LTC1298_SHDN();

gsLTC1298.fReferenceVoltage = LTC1298_USED_REFERENCE;
gsLTC1298.ui16Calib_Zero_Val = LTC1298_ZERO_VALUE;
gsLTC1298.ui16Calib_Reference_Val = LTC1298_REFERENCE_VALUE;
ADC_CalculateFaktor( &gsLTC1298 );

gu16SelectedRingBufSize = RINGBUF_SIZE_MAX;
gpu16RingBuf_Parser = gau16ADC_RingBuf;
gpu16RingBuf_Tail = (gau16ADC_RingBuf + RINGBUF_SIZE_MAX) - 1; // Merke von 0..9 = 10, also 9 ist ende
};


//Diese Funktion ist 1* auszufhren, "nachdem" die Kalibrierung Vorgenommen wurde.
// ************************************************
void ADC_CalculateFaktor( ADC_CALCULATE_TYPE * psADC )
// ************************************************
{// Referezspannung / (Messwert -ZeroOffset)
psADC->fVoltProBit = psADC->fReferenceVoltage / (psADC->ui16Calib_Reference_Val - psADC->ui16Calib_Zero_Val);
};


// ************************************************
float CalcLVolt_LTC1298( uint16_t u16ReadedVal )
// ************************************************
{
return ( (u16ReadedVal - gsLTC1298.ui16Calib_Zero_Val) * gsLTC1298.fVoltProBit);
};



// ************************************************
void Check_LTC1298_Orders( char *pcSmd, float *pfValue1)
// ************************************************
{
if(!strcasecmp_P( pcSmd, PSTR("SREF"))  )  //Set Calc Value Zero
	{
	gsLTC1298.fReferenceVoltage = *pfValue1; //USE_PREFIX_FLAG
	};	
if(!strcasecmp_P( pcSmd, PSTR("SCVZ"))  )  //Set Calc Value Zero
	{
	gsLTC1298.ui16Calib_Zero_Val = (uint16_t)*pfValue1; //USE_PREFIX_FLAG
	};	
if(!strcasecmp_P( pcSmd, PSTR("SCVR"))  )  //Set REFERENCE VOLTAGE ( before Calibration )
	{
	gsLTC1298.ui16Calib_Reference_Val = (uint16_t)*pfValue1; //USE_PREFIX_FLAG
	};		
if(!strcasecmp_P( pcSmd, PSTR("CALCFAKT"))  )  //Neue Werte berechnen
	{	
	ADC_CalculateFaktor( &gsLTC1298 );
	};
if(!strcasecmp_P( pcSmd, PSTR("SBUFS"))  )  //Setz Buffer Size
	{	
	if(*pfValue1 <= RINGBUF_SIZE_MAX)
		{
		gu16SelectedRingBufSize = (uint16_t)*pfValue1;
		gpu16RingBuf_Tail = (gau16ADC_RingBuf + gu16SelectedRingBufSize) -1;
		};	
	};
};


// ************************************************
void InsertInRingBuf( uint16_t u16Val)
// ************************************************
{
if( gpu16RingBuf_Parser > gpu16RingBuf_Tail )
	{
	gpu16RingBuf_Parser = gau16ADC_RingBuf;	
	};
*gpu16RingBuf_Parser++ = u16Val;
};


// ************************************************
uint16_t GetRingBufVal( void )
// ************************************************
{
uint16_t u16NN;
uint32_t u32_Sampple = 0;
for(u16NN = 0; u16NN < gu16SelectedRingBufSize; u16NN++)
	{
	u32_Sampple += gau16ADC_RingBuf[ u16NN ];
	};
return (uint16_t)lround( (u32_Sampple / gu16SelectedRingBufSize) );
};
