
#ifndef DEBOUNCE_HEADER
#define DEBOUNCE_HEADER

typedef struct
	{
	uint32_t u32EventTime; //offen/geschlossen Zeit des Schalter fr Debounce
	uint8_t u8SWITCH_Flag;	// : 4 Status, Fr das Speichern des Status der Taste
	uint8_t u8SWITCH;	//  : 8 Tasten
	}KEY_STRUCT_TYPE;
	
	
#define SWITCH_PRESSED_DETECT	0x01
#define SWITCH_PRESSED			0x02
#define SWITCH_RELEASED_DETECT	0x04
#define SWITCH_RELEASED			0x08
//---------
#define SWITCH_INT_EVENT		0x10 
#define SWITCH_VALID			0x80 
//gsSWITCH.ucSWITCHFlag   

#define SWITCH_SWITCH_RELEASE_DELAY_TICKS	24	//~1/5 Sek1INTERRUPTS_PER_SEC_T2 244
#define SWITCH_SWITCH_PRESSED_DELAY_TICKS	10	//Beuetet 5MS mus mindest der selbe Wert gelesen sein.


extern void Check_INDEX_Switch(void);
extern void Switch_Index_ValidAction(void);

//Globals
extern SWITCH_STRUCT_TYPE gsSWITCH;

#endif //DEBONCE_HEADER
