/*
!! MAKEFILE Optimise normal = 2 !! But !! DANGER EEPROM INTERRUPT ETC..
 !!! SET COPT IN  FUSE BITS TO ENABLE XTAL !!!!!!!!!!!!!
 IF ( ? : )
 */


#include <avr\eeprom.h>	


//EEPROM
#define EEPROM_SECTION  __attribute__ ((section (".eeprom")))
#define IEEPROM_SIZE	512	//Internes EEPROM
#define EE_DUMMYLOAD 0x5AA5 //unwahrsch. wert 0101 1010 1010 0101
//If using 8 block by 512 max = 64 Byte/block
//#define IEEPROM_SECTIONSIZE	64   //by 8 Section



//EEPROM SAVED FLAGS
#define SELECT_INDEXSCAN_BY_START_FLAG	0x01	//(default 1 = ON )
#define SELECT_INDEX_SCAN_MODE_FLAG		0x02	//Speicherung eigentlich unntig..		
//gsStMPar.ucSelect_Flags


int CheckEEPROM_Valid(void);
void LoadParameter(void);
void SaveParameter(void
const char MCA_EEPROM_MSG[] PROGMEM	= "EEPROM";

uint16_t guiEEPDUMMY EEPROM_SECTION; //avoid using lowest adress.

typedef struct
	{	
	uint8_t ucaInEEPROMStr[12];	//Fr strlen( EEPROMVALID) = 11 + 1
	}EEPROM_STR_TYPE;	

//EEPROM VARIABLEN
//#define EEPROM_SECTION  __attribute__ ((section (".eeprom")))
//#define EE_DUMMYLOAD 0x5AA5 //unwahrsch. wert 0101 1010 1010 0101
//uint16_t guiEEPDUMMY EEPROM_SECTION = EE_DUMMYLOAD; //avoid using lowest adress.
//ohne Prdefintion
uint16_t guiEEPDUMMY EEPROM_SECTION; //avoid using lowest adress.
EEPROM_STR_TYPE gucaEEPStr EEPROM_SECTION;	//String [12], FR "EEPROMVALID"siehe main.H
STEPMPARTYPE gsEEPROMsStMPar EEPROM_SECTION;  //Parameterstruktur




//EEPROM
// ****************************************************************
void SaveParameter(void)
// ****************************************************************
{
//uint16_t uiDummy  EEPROM_SECTION  = 0; //avoid using lowest addresses
//EEPROM START AT ADRESS 2 (Wegen ersten 2 Byte fr Integer DUMMY)
//uiAdr=0;
strcpy_P(gcaStr, MCA_EEPROM_MSG);
strcat_P(gcaStr, MCA_VALID_MSG);
cli(); // Schalte Interrupts aus !!
//void eeprom_write_word (uint16_t *addr, uint16_t val)
eeprom_busy_wait();
eeprom_write_word( &guiEEPDUMMY, EE_DUMMYLOAD); //IN 0 NIX LADEN
//uiAdr=2;//Next Adress
//void eeprom_write_block (const void *buf, void *addr, size_t n)
eeprom_busy_wait();
eeprom_write_block((char*)gcaStr, &gucaEEPStr, sizeof(gucaEEPStr) );
//uiAdr+=uiSize;
//void eeprom_write_block (const void *buf, void *addr, size_t n)
eeprom_busy_wait();
eeprom_write_block((STEPMPARTYPE*)&gsStMPar, &gsEEPROMsStMPar, sizeof(STEPMPARTYPE));
sei(); // Schalte Interrupts wieder an !!
#if MSG_SUPPRESS_DIRECTIVE == 0
uart_puts_p( MCA_EEPROM_MSG );
uart_puts_p( MCA_SPACE_MSG );
Print_PStrCRLF(MCA_SAVE_CMD);
#endif
};



//EE
// *******************************************************************
int CheckEEPROM_Valid(void)
// *******************************************************************
{//return 0 = Fehler
uint16_t uiDummy; 
//uint16_t uiDummy  EEPROM_SECTION  = 0; //avoid using lowest addresses
//EEPROM START AT ADRESS 2 (Wegen ersten 2 Byte fr Integer DUMMY)
//uiAdr=2;
//Hilfsweise gcaNumStr.
strcpy_P(gcaNumStr, MCA_EEPROM_MSG);// DAS MUSS DRINSTEHEN
strcat_P(gcaNumStr, MCA_VALID_MSG); // DAS MUSS DRINSTEHEN
cli(); // Schalte Interrupts aus !!
eeprom_busy_wait();
uiDummy = eeprom_read_word(&guiEEPDUMMY); // 1. Dummy read 
//eeprom_read_block( (char*)gcaStr, &gucaEEPStr, (strlen(gcaNumStr) + 1) );
eeprom_busy_wait();
eeprom_read_block( &gcaStr[0], &gucaEEPStr, sizeof(gucaEEPStr) );
sei(); // Schalte Interrupts wieder an !!
*(gcaStr + strlen(gcaNumStr))= 0;	// [12]-1=11	 //Terminiere

uart_puts_p( MCA_EEPROM_MSG );
uart_puts_p( MCA_SPACE_MSG );
if( strncmp(gcaStr ,gcaNumStr,strlen(gcaNumStr)) ) //EEPROMVAILD --> Cmp=0
	{//!=
#if MSG_SUPPRESS_DIRECTIVE == 0
	Print_PStrCRLF( MCA_WRONG_MSG );
#endif
	//SaveParameter();
	return 0;		
	}
else
	{//OK
#if MSG_SUPPRESS_DIRECTIVE == 0
	Print_PStrCRLF( MCA_OK_MSG );
#endif
	};
return 1;
};


// ****************************************************************
void LoadParameter(void)
// ****************************************************************
{
if( CheckEEPROM_Valid() )
	{
	cli(); // Schalte Interrupts aus !!
//void  eeprom_read_block (void *buf, const void *addr, size_t n)
	eeprom_busy_wait();
	eeprom_read_block((STEPMPARTYPE*)&gsStMPar, &gsEEPROMsStMPar, sizeof(STEPMPARTYPE));
	sei(); // Schalte Interrupts wieder an !!
#if MSG_SUPPRESS_DIRECTIVE == 0
	uart_puts_p( MCA_EEPROM_MSG );
	Print_PStrCRLF( MCA_LOAD_CMD );
#endif
	};
};



//VERIY IMPORTANT....
//BEI FEHLER (EEPROM UNBESCHRIEBEN ; LADE WERTE
if( CheckEEPROM_Valid() )//return 0 = WRONG
	{
	LoadParameter();	//EEprom VALID CHECK INCLUDET !!!
	}
else
	{
	SaveParameter();
	};
