

// Verison 17.01.2019
/*
Christof Ermer
Regensburg
ChristofErmer@gmail.com

Variante 16 Bit Ringbuffer
*/


#ifndef MY_RING_BUFFER_H
	#define MY_RING_BUFFER_H

//Set on this Place Buffesize
// Normaly <= 256 is enough
//BUF_STRMAX never >256,  or change the Datatype from  HEAD & TAIL to "unsigned int". 

//RingBuf_Init( &gsCodesetStrBuf, gu8aCodeSetSrtr, GRSSE );
//Bsp RingBuf_Flush( &gsCodesetStrBuf );
//Returnvalues STR_BUF Read/write Functions, to check the state

/*
// DAS GEHT SO NICHT weil keine #define Konstatte
#if( ( RINGBUFF_SIZE) >= (RAMEND-0x60 ) )
	#error "size of RINGBUFF_SIZE larger than size of SRAM"
#endif

#if( ( RINGBUFF_SIZE - 1)  RINGBUFF_SIZE )
	#error RX buffer size is not a power of 2
#endif
*/

#include <stdint.h>

#ifndef RINGBUFF_SIZE
	#define RINGBUFF_SIZE 64U
#endif

//FLAG No_DATA oberhalb 0xFFFF
#define RING_NO_DATA			0x010000UL
// *********************************
typedef struct
// **************gcaStr*******************
{
uint8_t uxHead;
uint8_t uxTail;
uint8_t uxRingBufMask;
uint16_t *pauRingBuf;	// Pointer auf malloc Space
}RINGBUF_TYPE;

extern void RingBuf_Init(RINGBUF_TYPE * pRBuf, uint16_t * pu16Buffer, uint8_t uxArraySize); //always N^2 Size
	//RingBuf_Init( &gsMorseRingBuf, gau16MorseRxBuf, RINGBUFF_SIZE);
extern void RingBuf_Flush(RINGBUF_TYPE * pRBuf);
extern void RingBuf_WriteC(RINGBUF_TYPE * pRBuf, uint16_t u16Rx);  //Rckgabeflag: Ok--> 0
extern uint32_t RingBuf_ReadC(RINGBUF_TYPE * pRBuf );
extern uint8_t RingBuf_Bytes_Available(RINGBUF_TYPE * pRBuf); /* Bytes im RingBuf ? */


#endif // MY_RING_BUFFER_H